var decodeEntities = (function() {
  // this prevents any overhead from creating the object each time
  var element = document.createElement('div');

  function decodeHTMLEntities (str) {
    if(str && typeof str === 'string') {
      // strip script/html tags
      str = str.replace(/<script[^>]*>([\S\s]*?)<\/script>/gmi, '');
      str = str.replace(/<\/?\w(?:[^"'>]|"[^"]*"|'[^']*')*>/gmi, '');
      element.innerHTML = str;
      str = element.textContent;
      element.textContent = '';
    }

    return str;
  }

  return decodeHTMLEntities;
})();

var ImportMedia = function() {};
ImportMedia.prototype = {
    run: function(arguments) {
        var contents = document.getElementsByTagName('html')[0].innerHTML || "";
        var tracks = [];
                                   
        var idMatch = contents.match(/vk_id=([0-9]+)/);
        if (idMatch && idMatch.length > 1) {
        	my_id = idMatch[1];

            var match;
            var re = /title.{1,30}?>([\s\S]{1,70}?)<[\s\S]{1,300}?artist[\s\S]{1,30}?>([\s\S]{1,70}?)<[\s\S]{1,300}?"(http.+?mp3.+?)"/g;
            while (match = re.exec(contents)) {
                tracks.push({artist: match[2], title: match[1], url: match[3]});
            //	tracks.push({title: "" + match[2] + " – " + match[1], url: match[3]});
            }

            if (tracks.length == 0) {
				var match;
	            var re = /data-audio="\[([0-9]+),([0-9]+),.*?(http.*?)&quot;,&quot;(.*?)&quot;,&quot;(.*?)&quot;/g;
	            while (match = re.exec(contents)) {
	                var url = JSON.parse("[\"" + match[3] + "\"]")[0]
	                tracks.push({artist: match[5], title: match[4], url: url});
	            }
            }


        	var r = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMN0PQRSTUVWXYZO123456789+/=",
        	l = {
                v: function(t) {
                    return t.split("").reverse().join("")
                },
                r: function(t, e) {
                    t = t.split("");
                    for (var i, o = r + r, a = t.length; a--;)
                        i = o.indexOf(t[a]), ~i && (t[a] = o.substr(i - e, 1));
                    return t.join("")
                },
                s: function(t, e) {
                    var i = t.length;
                    if (i) {
                        var o = s(t, e),
                        a = 0;
                        for (t = t.split(""); ++a < i;)
                            t[a] = t.splice(o[i - 1 - a], 1, t[a])[0];
                        t = t.join("")
                    }
                    return t
                },
                i: function(t, e) {
                    return l.s(t, e ^ my_id)
                },
                x: function(t, e) {
                    var i = [];
                    return e = e.charCodeAt(0),
                    each(t.split(""), function(t, o) {
                         i.push(String.fromCharCode(o.charCodeAt(0) ^ e))
                         }),
                    i.join("")
                }
        	}

        	function getRealLink(t) {
        	    if ( ~t.indexOf("audio_api_unavailable")) {
        	        var e = t.split("?extra=")[1].split("#"),
        	        o = "" === e[1] ? "" : a(e[1]);
        	        if (e = a(e[0]),
        	            "string" != typeof o || !e)
        	            return t;
        	        o = o ? o.split(String.fromCharCode(9)) : [];
        	        for (var s, r, n = o.length; n--;) {
        	            if (r = o[n].split(String.fromCharCode(11)),
        	                s = r.splice(0, 1, e)[0], !l[s])
        	                return t;
        	            e = l[s].apply(null, r)
        	        }
        	        if (e && "http" === e.substr(0, 4))
        	            return e
        	            }
        	    return t
        	}

        	function a(t) {
        	    if (!t || t.length % 4 == 1)
        	        return !1;
        	    for (var e, i, o = 0, a = 0, s = ""; i = t.charAt(a++);)
        	        i = r.indexOf(i), ~i && (e = o % 4 ? 64 * e + i : i,
        	                                 o++ % 4) && (s += String.fromCharCode(255 & e >> (-2 * o & 6)));
        	    return s
        	}

        	function s(t, e) {
        	    var i = t.length,
        	    o = [];
        	    if (i) {
        	        var a = i;
        	        for (e = Math.abs(e); a--;)
        	            e = (i * (a + 1) ^ e + a) % i,
        	            o[a] = e
        	            }
        	    return o
        	}

        	tracks.forEach(function(track) {
        	    track.artist = track.artist.replace(/&amp;/g, '&');
        	    track.title = track.title.replace(/&amp;/g, '&');
        		track.url = getRealLink(track.url);
        		if (track.url.indexOf(".mp3?") == -1) {
        		    if (track.url.indexOf("/audios/") == -1) {
                        track.url = track.url.replace(/\/\w*\/(\w*)\/index.m3u8/,'/$1.mp3');
                    } else {
                        track.url = track.url.replace(/\/\w*\/audios\/(\w*)\/index.m3u8/,'/audios/$1.mp3');
                    }
                }
        	});

        	tracks = tracks.filter(function(track) {
        	    return track.url.indexOf("unavailable") == -1;
        	});
        }
        
        //------------------------------------------------------------------------

        if (tracks.length == 0) {
            var match;
//            //var re = /title=\\"(.{1,200}?)\\".*?(http.{1,100}?videoplayback.{1,2000}?)\\"/gs;
            var regex = /(http[\s\S]{1,100}?videoplayback[\s\S]{1,2000}?)\\"/g;
            while (match = regex.exec(contents)) {
                var url = match[1] || "";
                var title = document.title.replace(" - YouTube", "") || "";
                url = decodeEntities(url) || "";
                url = decodeURIComponent(JSON.parse('"' + url + '"')) || "";
                url = decodeURIComponent(JSON.parse('"' + url + '"')) || "";
                tracks.push({artist: "", title: title, url: url});
                break;
            }
        }

        if (tracks.length == 0) {
            var match;
            var re = /"title":"([\s\S]{1,200}?)"[\s\S]*?(http[\s\S]{1,100}?\/videoplayback[\s\S]{1,2000}?)\\"/g;
            while (match = re.exec(contents)) {
                var title = match[1] || "";
                var url = match[2] || "";
                var url = decodeURIComponent(JSON.parse('"' + url + '"')) || "";
                var url = decodeURIComponent(JSON.parse('"' + url + '"')) || "";
                tracks.push({artist: "", title: title, url: url});
            }
        }
                                   
        //------------------------------------------------------------------------
                                   
        if (tracks.length == 0) {
            var url = window.location.href || document.URL || "";
            var title = url.substring(url.lastIndexOf('/') + 1);
            title = decodeURIComponent(title);
            if (url.length > 0 && url.indexOf(".mp3") !== -1) {
                tracks.push({artist: "", title: title, url: url});
            }
        }

        arguments.completionFunction({"media": tracks});
    }
};
var ExtensionPreprocessingJS = new ImportMedia;
